Graphics3D 800,600,32
ClearTextureFilters()
cam=CreateCamera()
PositionEntity cam,-1,0,-3
HidePointer
light=CreateLight()


Global sprite=CreateSprite()
Global height=LoadTexture("height.bmp")
EntityTexture sprite,height,0,1

Global normalsprite=CreateSprite()
PositionEntity normalsprite,-2.1,0,0
Global normal=CreateTexture(TextureWidth(height),TextureHeight(height),32+16)
EntityTexture normalsprite,normal,0,0
TextureBlend normal,4
;Global mud=LoadTexture("texturemud.bmp")
;EntityTexture normalsprite,mud,0,1

Global backround=LoadImage("backround.png")
Global pointer=LoadImage("cursor.bmp")

Dim x3#(2,2)
Dim x3color(2,2,2)
Dim cache_array(TextureWidth(height),TextureHeight(height))
Dim color_array(TextureWidth(height),TextureHeight(height),2)
cache_texture(height)

red_#=128
green_#=128
blue_=190

Global strength#=2
Global convert=0
Global stimer=0
Global etimer=0

Global b_=190

Global mouse_x
Global mouse_y

Global angle#=50

Global click_time=1000
Global click_timer=MilliSecs()
Global mouse_hit=0
Global pressed=0

Type button
	Field x,y
	Field width
	Field height
	Field colour#
	Field number
	Field caption$
	Field state ; 0=normal 1=mouseover
	Field btype
End Type

b.button=New button
	b\x=455
	b\y=450
	b\width=160
	b\height=20
	b\caption$="Convert"
	b\number=0
	b\state=0
	b\colour=150
	b\btype=0

b.button=New button
	b\x=30
	b\y=280
	b\width=20
	b\height=20
	b\caption$="-"
	b\number=1
	b\state=0
	b\colour=150
	b\btype=0

b.button=New button
	b\x=80
	b\y=280
	b\width=20
	b\height=20
	b\caption$="+"
	b\number=2
	b\state=0
	b\colour=150
	b\btype=0

b.button=New button
	b\x=15
	b\y=250
	b\width=100
	b\height=20
	b\caption$="Strength"
	b\number=2
	b\state=0
	b\colour=70
	b\btype=1

b.button=New button
	b\x=25
	b\y=350
	b\width=80
	b\height=20
	b\caption$="Save"
	b\number=3
	b\state=0
	b\colour=150
	b\btype=0

b.button=New button
	b\x=30
	b\y=224
	b\width=20
	b\height=20
	b\caption$="-"
	b\number=4
	b\state=0
	b\colour=150
	b\btype=0

b.button=New button
	b\x=80
	b\y=224
	b\width=20
	b\height=20
	b\caption$="+"
	b\number=5
	b\state=0
	b\colour=150
	b\btype=0

b.button=New button
	b\x=25
	b\y=196
	b\width=30
	b\height=20
	b\caption$="-10"
	b\number=6
	b\state=0
	b\colour=150
	b\btype=0

b.button=New button
	b\x=75
	b\y=196
	b\width=30
	b\height=20
	b\caption$="+10"
	b\number=7
	b\state=0
	b\colour=150
	b\btype=0

b.button=New button
	b\x=15
	b\y=170
	b\width=100
	b\height=20
	b\caption$="Blue"
	b\number=2
	b\state=0
	b\colour=70
	b\btype=1


While Not KeyHit(1)

	Cls

	mouse_x=MouseX()
	mouse_y=MouseY()
	If MouseDown(1) Then
		If MilliSecs()>click_time+click_timer Then
			pressed=pressed+1:If pressed>2 Then pressed=2
			If pressed=1 Then
				click_time=500
				click_timer=MilliSecs()
				mouse_hit=1
			ElseIf pressed=2
				click_time=50
				click_timer=MilliSecs()
				mouse_hit=1
			End If
		Else
			mouse_hit=0
		End If
	Else
		mouse_hit=0
		click_time=0
		click_timer=0
		pressed=0
	End If

	If KeyHit(3) Then TextureBlend normal,4
	If KeyHit(4) Then TextureBlend normal,1
	
	If KeyDown(200) Then green_=green_+2:If green_>255 Then green_=255
	If KeyDown(208) Then green_=green_-2:If green_<0 Then green_=0
	If KeyDown(203) Then red_=red_+2:If red_>255 Then red_=255
	If KeyDown(205) Then red_=red_-2:If red_<0 Then red_=0
	
	If convert=1 Then
		angle=angle+1
		red_=Cos(angle)
		green_=Sin(angle)
	End If
	EntityColor normalsprite,128+(128*red_),128+(128*green_),blue_
	
	updatebuttons()
	UpdateWorld
	RenderWorld
	DrawImage backround,0,0
	drawbuttons()
	DrawImage pointer,mouse_x,mouse_y
	;Text 0,0," green="+green_+" red="+red_
	;Text 0,10," press 1 to generate normal map! Arrow keys to change light direction!"
	Text 200,140," Normal Map                         Height Map "
	Text 64,233,b_,True,True
	Text 52,283,strength
	;If convert=1 Then Text 0,20," time_taken="+(etimer-stimer)
	Flip
Wend
End

Function drawbuttons()
	For b.button=Each button
		Color b\colour,b\colour,b\colour
		Rect b\x,b\y,b\width,b\height
		Color 255,255,255
		Text b\x+(b\width/2),b\y+(b\height/2),b\caption$,True,True
	Next
End Function

Function updatebuttons()

	For b.button=Each button
		If b\btype=0 Then
				If mouse_hit=1 Then
						If RectsOverlap(mouse_x,mouse_y,1,1,b\x,b\y,b\width,b\height) Then
	
							If b\number=0 Then
								convert_texture(height,normal,strength,b_)
								convert=1
							ElseIf b\number=1 Then
								strength=strength-0.1
								If strength<0 Then strength=0
							ElseIf b\number=2 Then
								strength=strength+0.1
								If strength>10 Then strength=10
							ElseIf b\number=3 Then
								SaveBuffer (TextureBuffer(normal),"NormalMap.bmp")
							ElseIf b\number=4 Then
								b_=b_-1
								If b_<0 Then b_=0
							ElseIf b\number=5 Then
								b_=b_+1
								If b_>255 Then b_=255
							ElseIf b\number=6 Then
								b_=b_-10
								If b_<0 Then b_=0
							ElseIf b\number=7 Then
								b_=b_+10
								If b_>255 Then b_=255
							End If
						End If
	
				End If

		End If
	Next
End Function
					

Function convert_texture(texture,texture1,strength#,b=190)

	LockBuffer TextureBuffer(texture)
	LockBuffer TextureBuffer(texture1)
	
	For loopy=0 To TextureHeight(texture)-1
		For loopx=0 To TextureWidth(texture)-1
		
			
			For tloop=0 To 2
				For t1loop=0 To 2
				
					If loopx+(tloop-1)<0 Then
						x_value=TextureWidth(texture)-1
					ElseIf loopx+(tloop-1)>TextureWidth(texture)-2 Then
						x_value=0
					Else
						x_value=loopx+tloop
					End If
					
					If loopy+(t1loop-1)<0 Then
						y_value=TextureHeight(texture)-1
					ElseIf loopy+(t1loop-1)>TextureHeight(texture)-1 Then
						y_value=0
					Else
						y_value=loopy+t1loop
					End If
					
					x3(tloop,t1loop)=color_array(x_value,y_value,0)

				Next
			Next
			
			
			
			; RED COLOR!
			x10=128+(x3(0,1)-x3(1,1))*strength
			x11=128+(x3(1,1)-x3(2,1))*strength
			
			xf1=(x10+x11)/2
			x3color(1,1,0)=xf1
			
			; GREEN COLOR!
			y10=128+(x3(1,1)-x3(0,0))*strength
			y11=128+(x3(1,2)-x3(1,1))*strength
			
			yf1=(y10+y11)/2
			x3Color(1,1,1)=yf1

			; Remember the 3x3 sampling only creates one pixel!
			;b=190
			newrgb= a*16777216+x3color(1,1,0)*65536+x3color(1,1,1)*256+b; combine the ARGB back into a number
			WritePixelFast(loopx,loopy,newrgb,TextureBuffer(texture1)); write the info back to the texture

		Next
	
	Next
	
	UnlockBuffer TextureBuffer(texture1)
	UnlockBuffer TextureBuffer(texture)
	

End Function


Function cache_texture(texture)
	LockBuffer TextureBuffer(texture)
	For loopy=0 To TextureHeight(texture)-1
		For loopx=0 To TextureWidth(texture)-1
			cache_array(loopx,loopy)=ReadPixelFast(loopx,loopy,TextureBuffer(texture))
			RGB1=cache_array(loopx,loopy)
			color_array(loopx,loopy,0)=(RGB1 And $FF0000)/$10000
			color_array(loopx,loopy,1)=(RGB1 And $FF00)/$100
			color_array(loopx,loopy,2)=RGB1 And $FF
		Next
	Next
	UnlockBuffer TextureBuffer(texture)
End Function